--with trace
without warning
without type_check
include machine.e
include graphics.e
include image.e
include ports.e
include font.e
include pic_load.e
include key_read.e
include gamepad.e
include xmfx.e
include xmobj.e
include xmmaps.e

global atom VIRTUAL,MAP,Speed,sizer,maplong,safe,oldx,dr,santamove,check,ASpeed,
	    jump,air,jumpover,Height,Fall,bonus,wasover,Jump,overjump,JSpeed,
	    shooting,Shoot,overshot,rcheck,lcheck,actives,ObjSpeed,spark,sanim,
	    count,last,elapsed,framecount,clocks,timers,holdgift,skip,count2,
	    PleaseKill,deadglit,init,Lives,Canes,Score,DEAD,curlev
global sequence place,background,reg_list,key,oldplace,blockers,frame,keys,
		shotloc,TheMap,TheLev
object spare

global constant WIDTH=8,
	 HEIGHT=8,
	 VIDEO=#A0000,
	 RIGHT=1,
	 LEFT=2,
	 HIGH=1,
	 LOW=2,
	 TMR_CTRL = #43,  
	 TMR0_COUNT = #40
	 
curlev=1
Lives=5
Canes=0
Score=0
spare=fload("tradit13.f")
tick_rate(100)
framecount=.025
Speed=3
JSpeed=1.5
ASpeed=.4
ObjSpeed=.1
jump=0
safe=1
spare=graphics_mode(19)
all_palette(Palette/4)
spark=0


reg_list = repeat(0, 10)
-- function: AH = #10 AL= #01 => fix color of border
reg_list[REG_AX] = #1001
-- BH : set color of border (0000 is black)
reg_list[REG_BX] = #0000
-- Call DOS interrupt #10
reg_list = dos_interrupt(#10, reg_list)

include xmproc.e

--KILLOBJECT()-----------------------------------------------------------------

procedure KillObject(atom N)
    actives=actives[1..N-1] & actives[N+1..length(actives)]
    count=count+1
end procedure

--UPDATE()---------------------------------------------------------------------

global procedure update(atom item)
    if item=1 then
	polygon(BLACK,1,{{48,176},{48,190},{58,190},{58,176}})
	fx=48 fy=176
	fprint(sprintf("%01d",Lives))
    elsif item = 2 then
	polygon(BLACK,1,{{110,176},{110,190},{130,190},{130,176}})
	fx=110 fy=176
	fprint(sprintf("%02d",Canes))
    elsif item = 3 then
	polygon(BLACK,1,{{160,176},{160,190},{220,190},{220,176}})
	fx=160 fy=176
	fprint(sprintf("%06d",Score))
    end if
end procedure

--ACTIVATE()-------------------------------------------------------------------

procedure activate(atom N)
    atom typ
    typ=actives[N][6]
    if typ = 1 then
	spark=10
	KillObject(N)
	Canes=Canes+1
	if Canes=50 then
	    Canes=0
	    Lives=Lives+1
	    update(1)
	end if
	update(2)
	Score=Score+100
	update(3)
    elsif typ = 2 then
	DieSanta(N)
    elsif typ = 3 then
	if not holdgift then
	    holdgift=1
	    actives[N][STATE]=FALL
	    spark=10
	end if
    end if
end procedure

--TEST_PC()--------------------------------------------------------------------

global function test_pc(atom N,atom eye)
    atom xlong,ylong,div,checker
    sequence counter
    counter={}
    checker=0
    xlong=length(actives[N][4][1][1][1])
    ylong=length(actives[N][4][1][1])
    div=floor(xlong/16)
    if eye = 1 then
	if actives[N][3][1] >= maplong then
	    actives[N][2][1]=maplong-xlong-1
	    actives[N][3][1]=maplong-1
	    return 1
	end if
	if findblock(actives[N][3][1],actives[N][3][2]-1) then
	    actives[N][2][1]=floor(actives[N][2][1]/16)*16+7  
	    actives[N][3][1]=actives[N][2][1]+xlong
	    return 1
	end if
	return 0
    end if
    if eye = 2 then
	if actives[N][2][1] <= 0 then
	    actives[N][2][1]=1
	    actives[N][3][1]=xlong+1
	    return 1
	end if
	if findblock(actives[N][2][1],actives[N][3][2]-1) then
	    actives[N][2][1]=floor(actives[N][2][1]/16+1)*16-2  
	    actives[N][3][1]=actives[N][2][1]+xlong
	return 1
	end if
	return 0
    end if
    if eye=3 then
	if actives[N][XY1][2] < 0 then
	    actives[N][XY1][2] = 0
	    actives[N][XY2][2]=ylong
	end if
    end if
    if eye=4 then
	if actives[N][XY2][2]>160 then
	    KillObject(N)
	end if
	if findblock(actives[N][XY1][1],actives[N][XY2][2]) then
	    checker=1
	end if
	for i = 1 to div do
	    if findblock(actives[N][XY1][1]+i*16,actives[N][XY2][2]) then
		checker=1
	    end if
	end for
	if findblock(actives[N][XY2][1],actives[N][XY2][2]) then
	    checker=1
	end if
	if checker=0 then
	    return 1
	else
	    actives[N][STATE]=WALK
	    actives[N][XY1][2]=floor(actives[N][XY1][2]/20+2)*20-ylong
	    actives[N][XY2][2]=actives[N][XY1][2]+ylong
	    return 0
	end if
    end if
    if eye=5 then
	init=0
	if findblock(actives[N][XY1][1],actives[N][XY2][2]) then
	    checker=1
	else
	    init=1
	end if
	for i = 1 to div do
	    if findblock(actives[N][XY1][1]+i*16,actives[N][XY2][2]) then
		checker=1
	    else
		init=1
	    end if
	end for
	if findblock(actives[N][XY2][1],actives[N][XY2][2]) then
	    checker=1
	else
	    init=1
	end if
	if checker=1 then
	    actives[N][INITIAL]=1
	    if init then
		return 1
	    else
		return 0
	    end if
	else
	    if actives[N][MOVTYPE]=DUMB or not actives[N][INITIAL] then
		actives[N][STATE]=FALL
	    end if
	end if
	return 1    
    end if
end function


--MOVE_PC()--------------------------------------------------------------------

procedure move_pc(atom N)
    atom typ
    typ=actives[N][8]
    if typ then
	if actives[N][7] = LEFT then
	    if actives[N][STATE]=WALK then
		actives[N][2][1]=actives[N][2][1]-actives[N][9]
		actives[N][3][1]=actives[N][3][1]-actives[N][9]
		if actives[N][1]=ENEMY then
		if test_pc(N,2) then
		    actives[N][7]=RIGHT
		end if
		if actives[N][MOVTYPE] != BIRD then
		if test_pc(N,5) then
		    if actives[N][MOVTYPE]=SMART and actives[N][INITIAL] then
			actives[N][7]=RIGHT
		    end if
		end if
		end if
		elsif actives[N][1]=BULLET then
		    if actives[N][XY1][1]<0 then
			PleaseKill=N
			skip=1
			return
		    end if
		end if  
	    elsif actives[N][STATE]=FALL then
		actives[N][2][1]=actives[N][2][1]-actives[N][9]
		actives[N][3][1]=actives[N][3][1]-actives[N][9]
		if test_pc(N,2) then
		end if
		actives[N][2][2]=actives[N][2][2]+actives[N][9]*2
		actives[N][3][2]=actives[N][3][2]+actives[N][9]*2
		if test_pc(N,4) then
		end if
	    end if
	else
	    if actives[N][STATE]=WALK then
		actives[N][2][1]=actives[N][2][1]+actives[N][9]
		actives[N][3][1]=actives[N][3][1]+actives[N][9]
		if actives[N][1]=ENEMY then
		if test_pc(N,1) then
			actives[N][7]=LEFT
		end if
		if actives[N][MOVTYPE] != BIRD then
		if test_pc(N,5) then
		    if actives[N][MOVTYPE]=SMART then
			actives[N][7]=LEFT
		    end if
		end if
		end if
		elsif actives[N][1]=BULLET then
		    if actives[N][XY2][1]>maplong then
			PleaseKill=N
			skip=1
			return
		    end if
		end if
	    elsif actives[N][STATE]=FALL then
		actives[N][2][1]=actives[N][2][1]+actives[N][9]
		actives[N][3][1]=actives[N][3][1]+actives[N][9]
		if test_pc(N,1) then
		end if
		actives[N][2][2]=actives[N][2][2]+actives[N][9]*2
		actives[N][3][2]=actives[N][3][2]+actives[N][9]*2
		if test_pc(N,4) then
		end if
	    end if
	end if
    end if
end procedure

--DOGLITTER()------------------------------------------------------------------

procedure DoGlitter(atom N)
    atom reddog,x,y
    actives[N][DR]=actives[N][DR]-1
    reddog=6-floor(actives[N][DR]/6+1)
    x=actives[N][XY1][1]-5
    y=actives[N][XY1][2]-7
    draw_sprite(flash[reddog],{x,y})
end procedure

--DOGLIT()---------------------------------------------------------------------

procedure DoGlit()
    atom reddog
    deadglit[1]=deadglit[1]-1
    reddog=6-floor(deadglit[1]/6+1)
    draw_sprite(flash[reddog],deadglit[2])
    draw_sprite(flash[reddog],deadglit[3])
end procedure

--GIFTHIT()--------------------------------------------------------------------

function GiftHit(atom i, atom N)
    sequence xys, xye
    xys={actives[N][XY1][1],actives[N][XY1][2]+5}
    xye={actives[i][XY1][1],actives[i][XY2][1],actives[i][XY1][2],
	 actives[i][XY2][2]}
    if xys[1] > xye[1] and xys[1] < xye[2] then
	if xys[2] > xye[3] and xys[2] < xye[4] then
	    return 1
	elsif xys[2]+20 > xye[3] and xys[2]+20 < xye[4] then
	    return 1
	end if
    end if
    if xys[1]+20 > xye[1] and xys[1]+20 < xye[2] then
	if xys[2] > xye[3] and xys[2] < xye[4] then
	    return 1
	elsif xys[2]+20 > xye[3] and xys[2]+20 < xye[4] then
	    return 1
	end if
    end if
    return 0
end function

--CHECKGIFT()------------------------------------------------------------------

function CheckGift(atom N)
    count2=0
    for i = 1 to length(actives) do
	if actives[i][1]=ENEMY then
	    if GiftHit(i, N) then
		if i < N then
		    deadglit={20,actives[N][XY1],actives[i][XY1]}
		    KillObject(i)
		    KillObject(N-1)
		    Score=Score+250
		    update(3)
		    return 1
		else
		    deadglit={20,actives[N][XY1],actives[i][XY1]}
		    PleaseKill=i+count
		    KillObject(N)
		    Score=Score+250
		    update(3)
		    return 1
		end if
	    end if
	end if
    end for
    return 0
end function

--DOGIFT()---------------------------------------------------------------------

procedure DoGift(atom N)
    if actives[N][STATE]=WALK then
	if actives[N][ASPEED] then
	    if actives[N][ASPEED] > 1 then
		actives[N][XY1][2]=actives[N][XY1][2]-2
		actives[N][XY2][2]=actives[N][XY2][2]-2
		actives[N][ASPEED]=actives[N][ASPEED]-2
	    else
		actives[N][XY1][2]=actives[N][XY1][2]+2
		actives[N][XY2][2]=actives[N][XY2][2]+2
		if findblock(actives[N][XY1][1],actives[N][XY2][2]) or
		   findblock(actives[N][XY1][1]+10,actives[N][XY2][2]) or
		   findblock(actives[N][XY2][1],actives[N][XY2][2]) then
		   actives[N][XY1][2]=floor(actives[N][XY2][2]/20)*20-25
		   actives[N][XY2][2]=actives[N][XY1][2]+25
		   actives[N][ASPEED]=0
		end if
	    end if
	end if
    elsif actives[N][STATE]=FALL then
	if dr=RIGHT then
	    actives[N][XY1][1]=place[1]+18
	    actives[N][XY1][2]=place[2]+10
	    actives[N][XY2][1]=actives[N][XY1][1]+20
	    actives[N][XY2][2]=actives[N][XY1][2]+25
	else
	    actives[N][XY1][1]=place[1]-13
	    actives[N][XY1][2]=place[2]+10
	    actives[N][XY2][1]=actives[N][XY1][1]+20
	    actives[N][XY2][2]=actives[N][XY1][2]+25
	end if
    elsif actives[N][STATE]=JUMP then
	    if actives[N][MOVTYPE]=RIGHT+10 then
		actives[N][XY1][1]=actives[N][XY1][1]+actives[N][SPEED]                
		actives[N][XY2][1]=actives[N][XY2][1]+actives[N][SPEED]                
		if not CheckGift(N) then
		if actives[N][XY2][1]>maplong+5 or actives[N][XY1][1]>place[1]+175 then
		    KillObject(N)
		    shooting=0
		    safe=1
		    holdgift=0
		    skip=1
		end if
		else
		    shooting=0
		    safe=1
		    holdgift=0
		    skip=1
		end if
	    else
		actives[N][XY1][1]=actives[N][XY1][1]-actives[N][SPEED]                
		actives[N][XY2][1]=actives[N][XY2][1]-actives[N][SPEED]                
		if not CheckGift(N) then
		if actives[N][XY1][1]<-5 or actives[N][XY2][1]<place[1]-150 then
		    KillObject(N)
		    shooting=0
		    safe=1
		    holdgift=0
		    skip=1
		end if
		else
		    shooting=0
		    safe=1
		    holdgift=0
		    skip=1
		end if
	    end if           
    end if
end procedure

--MAKEBULLET()-----------------------------------------------------------------

procedure MakeBullet(atom N, sequence nex)
    atom M
    if actives[N][DR]=LEFT then
	actives=append(actives,nex)
	M=length(actives)
	actives[M][DR]=LEFT
	actives[M][XY1]=actives[N][XY1]
	actives[M][XY1][2]=actives[M][XY1][2]+15
	actives[M][XY2][1]=actives[M][XY1][1]+length(actives[M][FRAME][1][1][1])
	actives[M][XY2][2]=actives[M][XY1][2]+length(actives[M][FRAME][1][1])
    else
	actives=append(actives,nex)
	M=length(actives)
	actives[M][DR]=RIGHT
	actives[M][XY1]=actives[N][XY1]
	actives[M][XY1][1]=actives[M][XY1][1]+length(actives[N][FRAME][1][1][1])
	actives[M][XY1][2]=actives[M][XY1][2]+15
	actives[M][XY2][1]=actives[M][XY1][1]+length(actives[M][FRAME][1][1][1])
	actives[M][XY2][2]=actives[M][XY1][2]+length(actives[M][FRAME][1][1])
    end if
end procedure

--DO_OBJECTS()-----------------------------------------------------------------

procedure DoObjects()
    --atom xlong
    count=0
    skip=0
    PleaseKill=0
    if length(TheLev[2]) then
	if (TheLev[2][1][XY1][1]-place[1]) < 200 then
	    actives=append(actives,TheLev[2][1])
	    if length(TheLev[2]) > 1 then
		TheLev[2]=TheLev[2][2..length(TheLev[2])]
	    else
		TheLev[2]={}
	    end if
	end if
    end if
    if length(TheLev[1]) then
	if (place[1]-TheLev[1][1][XY2][1]) < 200 then
	    actives=append(actives,TheLev[1][1])
	    if length(TheLev[1]) > 1 then
		TheLev[1]=TheLev[1][2..length(TheLev[1])]
	    else
		TheLev[1]={}
	    end if
	end if
    end if
    if length(actives) then
	for i = 1 to length(actives) do
	    if actives[i-count][TYPE]=OBJECT then
		actives[i-count][ANIM]=actives[i-count][ANIM]+ObjSpeed
		if actives[i-count][ANIM]>=length(actives[i-count][FRAME])+1 then
			actives[i-count][ANIM]=1
		end if
		draw_sprite(actives[i-count][FRAME][floor(actives[i-count][5])],
			    actives[i-count][XY1])
	    elsif actives[i-count][TYPE]=ENEMY or actives[i-count][TYPE]=BULLET then
		actives[i-count][5]=actives[i-count][5]+actives[i-count][10]
		if actives[i-count][5] >= length(actives[i-count][4])+1 then
			actives[i-count][5]=1
		end if
		draw_sprite(actives[i-count][4][floor(actives[i-count][5])]
			    [actives[i-count][7]],actives[i-count][2])
		move_pc(i-count)
		if actives[i-count][SHOOTER][1] then
		    actives[i-count][SHOOTER][2]=actives[i-count][SHOOTER][2]+1
		    if actives[i-count][SHOOTER][2]=actives[i-count][SHOOTER][1] then
			MakeBullet(i-count,actives[i-count][SHOOTER][3])
			actives[i-count][SHOOTER][2]=0
		    end if
		end if
		if PleaseKill then
		    if i = PleaseKill then
			KillObject(i-count)
		    end if
		end if
	    elsif actives[i-count][TYPE]=GIFT then
		DoGift(i-count)
		if not skip then
		    draw_sprite(actives[i-count][FRAME][actives[i-count][ANIM]],
				actives[i-count][XY1])
		    if actives[i-count][DR] then
			DoGlitter(i-count)
		    end if
		end if
	    end if
	    if not skip then
		if check_contact(actives[i-count][2],actives[i-count][3]) and not DEAD then
		    activate(i-count)
		elsif actives[i-count][2][1] > place[1] then
		    if (actives[i-count][2][1]-place[1]) > 200 then
			if actives[i-count][1]=BULLET then
			    KillObject(i-count)
			else
			    if actives[i-count][1]=ENEMY then
			    if actives[i-count][8]=BIRD then
				actives[i-count][DR]=LEFT
			    end if
			    end if
			    TheLev[2] = prepend(TheLev[2],actives[i-count])
			    actives=actives[1..i-1-count] & 
			    actives[i+1-count..length(actives)]
			    count=count+1
			end if
		    end if
		else
		    if (place[1]-actives[i-count][3][1]) > 200 then
			if actives[i-count][1]=BULLET then
			    KillObject(i-count)
			end if
			if actives[i-count][1]=ENEMY then
			if actives[i-count][8]=BIRD then
			    actives[i-count][DR]=RIGHT
			end if
			end if
			TheLev[1] = prepend(TheLev[1],actives[i-count])
			actives=actives[1..i-count-1] & 
			actives[i+1-count..length(actives)]
			count=count+1
		    end if
		end if
	    end if
	end for
    end if
end procedure

--CHANGEGIFT()-----------------------------------------------------------------

procedure ChangeGift(atom N)
    atom xy1,xy2
    xy1=actives[N][XY1]
    xy2=actives[N][XY2]
    actives[N]=gift
    actives[N][ANIM]=rand(4)
    actives[N][XY1]=xy1
    actives[N][XY2]={{},{}}
    actives[N][XY2][1]=actives[N][XY1][1]+20
    actives[N][XY2][2]=actives[N][XY1][2]+25
    Score=Score+150
    update(3)
end procedure

--SHOTCONNECT()----------------------------------------------------------------

procedure shotconnect(atom help, atom N)
    atom x,y,doom
    doom=0
    if dr = RIGHT then
	x=shotloc[1]+help
    else
	x=shotloc[1]+80-help
    end if
    y=shotloc[2]
    if x > actives[N][XY1][1] and x < actives[N][XY2][1] then
	if y > actives[N][XY1][2] and y < actives[N][XY2][2] then
		ChangeGift(N)
		doom=1
	end if
    end if
    y=shotloc[2]+20
    if doom=0 then
    if x > actives[N][XY1][1] and x < actives[N][XY2][1] then
	if y > actives[N][XY1][2] and y < actives[N][XY2][2] then
		ChangeGift(N)
	end if
    end if
    end if
end procedure

--CHECKSHOT()------------------------------------------------------------------

procedure checkshot(atom newt)
    atom help
    for j = 1 to newt do
	help=j*18-18
	for i = 1 to length(actives) do
	    if actives[i][1]=ENEMY then
		shotconnect(help,i)
	    end if
	end for
    end for
end procedure

--DO_SHOT()--------------------------------------------------------------------

global procedure DoShot()
    shooting=shooting-1
    draw_sprite(glitter[(floor((29-shooting)/6)+1)][dr],shotloc)
    checkshot(floor((29-shooting)/6)+2)    
    if shooting=0 then
	frame=s1
	safe=1
    end if
end procedure

--DEADFRAME()------------------------------------------------------------------

procedure DeadFrame()
    santamove=santamove+.2
    draw_sprite(deadframe[floor(santamove)],place)
    if (santamove+.2)>=10 then
	Lives=Lives-1
	if Lives then
	    DEAD=10
	else
	    if graphics_mode(-1) then
	    end if
	    abort(0)
	end if
    end if
end procedure
    
--QUIITTER()-------------------------------------------------------------------

procedure quitter()
    polygon(BLACK,1,{{60,50},{60,100},{260,100},{260,50}})
    polygon(34,0,{{60,50},{60,100},{260,100},{260,50}})
    fx=68 fy=54
    fprint("Do You Really Want To Quit?")
    fx=120 fy=75
    ftc=11
    fprint("Y")
    ftc=200
    fprint("es or ")
    ftc=11
    fprint("N")
    ftc=200
    fprint("o")
    while 1 do
	keys=get_keys()
	if length(keys) then
	    if keys[1]=49 then
		return
	    elsif keys[1]=21 then
		exit
	    end if
	end if
    end while
    spare=graphics_mode(-1)
    abort(0)
end procedure

--INITLEVEL()------------------------------------------------------------------

procedure InitLevel()
    TheMap=Levels[curlev][1]
    TheLev=Levels[curlev][2]
    
blockers=Levels[curlev][4]
maplong=length(TheMap[1])*16
sizer=(length(TheMap)*20)*(length(TheMap[1])*16)
VIRTUAL=allocate(sizer)
MAP=allocate(sizer)

polygon(BLACK,1,{{0,0},{0,199},{319,199},{319,0}})
ftc=11
fx=85 fy=80
fprint(Levels[curlev][5])
while get_key()=-1 do
end while

--background=read_pcx(DIR & "bamboo.pcx")
--display_image({0,0},background[2])
background=read_pcx(DIR & "bottom.pcx")
display_image({0,160},background[2])
background=read_pcx(DIR & "santabig.pcx")
display_image({20,168},background[2])
background=read_pcx(DIR & "bigcane.pcx")
display_image({90,168},background[2])
    
    DEAD=0
    ftc=200
    update(1)
    update(2)
    update(3)
    actives={}
    air=0
    shooting=0
    Shoot=0
safe=1
Height=LOW
Jump=0
Fall=0
frame=s1
bonus=0
lcheck=0
rcheck=1
jumpover=0
santamove=1
PleaseKill=0
overjump=0
holdgift=0
deadglit={0,{},{}}
overshot=0
dr=RIGHT
place={20,80}
oldx=0
sanim=1
make_map()
mem_copy(VIRTUAL,MAP,sizer)
end procedure

-------------------------------------------------------------------------------

InitLevel()
while 1 do
    last=time() 
    elapsed = 0
    make_virtual()
    check=0
    if shooting then
	check=1
    end if
    key=get_keys()
    keys=GetKeyPad()
    if keys[siR_CTRL] or keys[siL_CTRL] and not DEAD then
	if overshot != 1 and safe and not shooting and not holdgift then
	    overshot=1
	    safe=0
	    frame=shooter
	    check=1
	    shooting=30
	    if dr=RIGHT then
		shotloc={place[1]+8,place[2]+10}
	    else
		shotloc={place[1]-70,place[2]+10}
	    end if
	end if
	if holdgift and not shooting then
	    overshot=1
	    safe=0
	    frame=shooter
	    check=1
	    shooting=2000
	    for i = 1 to length(actives) do
		if actives[i][1]=GIFT then
		    if actives[i][STATE]=FALL then
			actives[i][STATE]=JUMP
			if dr=RIGHT then
			    actives[i][MOVTYPE]=RIGHT+10
			else 
			    actives[i][MOVTYPE]=LEFT+10
			end if
		    end if
		end if
	    end for
	end if
    else
	overshot=0
    end if
    if keys[siR_ALT] or keys[siL_ALT] and not DEAD then
	if safe and overjump=0 then
	    jump=1
	    air=50
	    jumpover=0
	    Jump=1
	    frame=jumper
	    Height=LOW
	    wasover=0
	    safe=0
	    bonus=0
	    overjump=1
	elsif Jump then
	    jump=1
	end if
    else
	if safe then
	    overjump=0
	end if
    end if
    if find(333,key) and not DEAD then
	if safe then
	    place[1]=place[1]+Speed
	    dr=RIGHT
	    frame=walk
	    tester(1)
	    tester(5)
	    check=1
	elsif Jump then
	    jumpover=JSpeed
	    wasover=JSpeed
	    dr=RIGHT
	    if air=50 then
		bonus=1
	    end if
	elsif Fall then
	    jumpover=JSpeed
	    wasover=JSpeed
	    dr=RIGHT
	end if  
    end if
    if find(331,key) and not DEAD then
	if safe then
	    place[1]=place[1]-Speed
	    dr=LEFT
	    frame=walk
	    tester(2)
	    tester(5)
	    check=1
	elsif Jump then
	    jumpover=JSpeed
	    dr=LEFT
	    wasover=JSpeed
	    if air=50 then
		bonus=JSpeed
	    end if
	elsif Fall then
	    jumpover=JSpeed
	    wasover=JSpeed
	    dr=LEFT
	end if
    end if
    if find(25,key) then
	fx=10 fy=20
	fprint(sprintf("%04d",place[1]) & "," & sprintf("%04d",place[2]))
	while get_key() = -1 do
	end while
    end if
    if not DEAD then
    if Jump then
	DoJump()
    elsif Fall then
	DoFall()
    elsif shooting and not holdgift then
	DoShot()
    end if
    end if
    if DEAD then
	DeadFrame()
	if DEAD=10 then
	    InitLevel()
	end if
    end if
    if deadglit[1] then
	DoGlit()
    end if
    DoObjects()
    if find(1,key) then
	quitter()
    end if
    if check=0 then
	if safe then
	    frame=s1
	end if
    end if
    if not DEAD then
	santamove=santamove+ASpeed
	if santamove >= (length(frame)+1) then
	    santamove=1
	end if
	draw_santa(frame[floor(santamove)][dr])
    end if
    make_screen()
    elapsed=time()-last
    while elapsed < framecount do
	elapsed=time()-last
    end while
end while
spare=graphics_mode(-1)
